## apg 2.0.0b0

=== Makefile ===
##################################################################
# You can modify CC variable if you have compiler other than GCC
# But the code was designed and tested with GCC
CC = gcc

##################################################################
# Compilation flags
# You should comment the line below for AIX+native cc
FLAGS = -Wall

##################################################################
# Libraries
#
# You should comment the line below for OpenBSD 2.8 and above
LIBS = -lcrypt
LIBM = -lm
# Use lines below for cygwin
# LIBS = 
# LIBM =

##################################################################
# Support for crypted passwords
#
# DO NOT EDIT THE LINE BELOW !!!
CRYPTED_PASS = APG_DONOTUSE_CRYPT
# Coment this if you do not want to use crypted passwords output
CRYPTED_PASS = APG_USE_CRYPT

##################################################################
# Support for ANSI X9.17/SHA1 PRNG
#
# DO NOT EDIT THE LINE BELOW !!!
USE_SHA = APG_USE_SHA
# Coment this if you want to use PRNG X9.17 with SHA-1
USE_SHA = APG_DONOTUSE_SHA

##################################################################
# Directories
# Install dirs
INSTALL_PREFIX = /usr/local
APG_BIN_DIR = /bin
APG_MAN_DIR = /man/man1
APGD_BIN_DIR = /sbin
APGD_MAN_DIR = /man/man8

####################################################################
# If you plan to install APG daemon you should look at lines below #
####################################################################

####################################################################
# FreeBSD
#
# Uncoment NOTHING for FreeBSD
#

####################################################################
# Linux
#
# Uncoment line below for LINUX
#CS_LIBS = -lnsl

####################################################################
# Solaris
#
# Uncoment line below for Solaris
#CS_LIBS = -lnsl -lsocket

# ====== YOU DO NOT NEED TO MODIFY ANYTHING BELOW THIS LINE ======
# Find group ID for user root
FIND_GROUP = `grep '^root:' /etc/passwd | awk -F: '{ print $$4 }'`

PROGNAME = apg
CS_PROGNAME = apgd
BFM_PROGNAME = apgbfm
BFM_SOURCES = apgbfm.c bloom.c sha/sha.c errors.c
SOURCES = bloom.c ./sha/sha.c ./cast/cast.c rnd.c pronpass.c \
randpass.c restrict.c errors.c apg.c
HEADERS = owntypes.h pronpass.h randpass.h restrict.h errs.h rnd.h \
./cast/cast.h ./cast/cast_sboxes.h
OBJECTS = rnd.o ./cast/cast.o pronpass.o randpass.o restrict.o apg.o errors.o

all: cliserv standalone

cliserv: apgd apgbfm 

standalone: apg apgbfm

cygwin: standalone

apg:
	${CC} ${FLAGS} ${LIBS} ${LIBM} -D${CRYPTED_PASS} -D${USE_SHA} -o ${PROGNAME} ${SOURCES}

apgd:
	${CC} ${FLAGS} ${CS_LIBS} ${LIBM} -DCLISERV -D${USE_SHA} -o ${CS_PROGNAME} ${SOURCES}

apgbfm:
	${CC} ${FLAGS} ${LIBM} -o ${BFM_PROGNAME} ${BFM_SOURCES}

strip:
	strip ${PROGNAME}
	strip ${CS_PROGNAME}
	strip ${BFM_PROGNAME}

install:
	if test -x ./apg; then \
./mkinstalldirs ${INSTALL_PREFIX}${APG_BIN_DIR}; \
./mkinstalldirs ${INSTALL_PREFIX}${APG_MAN_DIR}; \
./install-sh -c -m 0755 -o root -g ${FIND_GROUP} ./apg ${INSTALL_PREFIX}${APG_BIN_DIR}; \
./install-sh -c -m 0444 ./doc/man/apg.1 ${INSTALL_PREFIX}${APG_MAN_DIR}; \
fi
	if test -x ./apgd; then \
./mkinstalldirs ${INSTALL_PREFIX}${APGD_BIN_DIR}; \
./mkinstalldirs ${INSTALL_PREFIX}${APGD_MAN_DIR}; \
./install-sh -c -m 0755 -o root -g ${FIND_GROUP} ./apgd ${INSTALL_PREFIX}${APGD_BIN_DIR}; \
./install-sh -c -m 0444 ./doc/man/apgd.8 ${INSTALL_PREFIX}${APGD_MAN_DIR}; \
fi
	if test -x ./apgbfm; then \
./mkinstalldirs ${INSTALL_PREFIX}${APG_BIN_DIR}; \
./mkinstalldirs ${INSTALL_PREFIX}${APG_MAN_DIR}; \
./install-sh -c -m 0755 -o root -g ${FIND_GROUP} ./apgbfm ${INSTALL_PREFIX}${APG_BIN_DIR}; \
./install-sh -c -m 0444 ./doc/man/apgbfm.1 ${INSTALL_PREFIX}${APG_MAN_DIR}; \
fi

install-cygwin:
	if test -x ./apg.exe; then \
./mkinstalldirs ${INSTALL_PREFIX}${APG_BIN_DIR}; \
./mkinstalldirs ${INSTALL_PREFIX}${APG_MAN_DIR}; \
./install-sh -c -m 0755 ./apg.exe ${INSTALL_PREFIX}${APG_BIN_DIR}; \
./install-sh -c -m 0444 ./doc/man/apg.1 ${INSTALL_PREFIX}${APG_MAN_DIR}; \
fi
	if test -x ./apgbfm.exe; then \
./mkinstalldirs ${INSTALL_PREFIX}${APG_BIN_DIR}; \
./mkinstalldirs ${INSTALL_PREFIX}${APG_MAN_DIR}; \
./install-sh -c -m 0755 ./apgbfm.exe ${INSTALL_PREFIX}${APG_BIN_DIR}; \
./install-sh -c -m 0444 ./doc/man/apgbfm.1 ${INSTALL_PREFIX}${APG_MAN_DIR}; \
fi

clean:
	rm -f ${CS_PROGNAME} ${PROGNAME} ${BFM_PROGNAME} ${OBJECTS} core*

## apg 2.2.3.dfsg.1

=== Makefile ===
--- 
+++ 
@@ -11,7 +11,8 @@
 ##################################################################
 # Libraries
 #
-# You should comment the line below for OpenBSD 2.8 and above
+# You should comment the line below ('LIBS= -lcrypt')for QNX RTP
+# 6.1.0, OpenBSD 2.8 and above, WIN32 (+MinGW)
 LIBS = -lcrypt
 LIBM = -lm
 # Use lines below for cygwin
@@ -24,6 +25,7 @@
 # DO NOT EDIT THE LINE BELOW !!!
 CRYPTED_PASS = APG_DONOTUSE_CRYPT
 # Coment this if you do not want to use crypted passwords output
+# or trying to build programm for win32
 CRYPTED_PASS = APG_USE_CRYPT
 
 ##################################################################
@@ -65,6 +67,12 @@
 # Uncoment line below for Solaris
 #CS_LIBS = -lnsl -lsocket
 
+####################################################################
+# QNX RTP 6.1.0
+#
+# Uncoment line below for QNX RTP 6.1.0
+#CS_LIBS = -lsocket
+
 # ====== YOU DO NOT NEED TO MODIFY ANYTHING BELOW THIS LINE ======
 # Find group ID for user root
 FIND_GROUP = `grep '^root:' /etc/passwd | awk -F: '{ print $$4 }'`
@@ -72,29 +80,29 @@
 PROGNAME = apg
 CS_PROGNAME = apgd
 BFM_PROGNAME = apgbfm
-BFM_SOURCES = apgbfm.c bloom.c sha/sha.c errors.c
+BFM_SOURCES = apgbfm.c bloom.c sha/sha.c errors.c getopt.c convert.c
 SOURCES = bloom.c ./sha/sha.c ./cast/cast.c rnd.c pronpass.c \
-randpass.c restrict.c errors.c apg.c
+randpass.c restrict.c errors.c apg.c getopt.c convert.c
 HEADERS = owntypes.h pronpass.h randpass.h restrict.h errs.h rnd.h \
-./cast/cast.h ./cast/cast_sboxes.h
+./cast/cast.h ./cast/cast_sboxes.h getopt.h convert.h
 OBJECTS = rnd.o ./cast/cast.o pronpass.o randpass.o restrict.o apg.o errors.o
+
+standalone: apg apgbfm
 
 all: cliserv standalone
 
 cliserv: apgd apgbfm 
 
-standalone: apg apgbfm
-
 cygwin: standalone
 
 apg:
-	${CC} ${FLAGS} ${LIBS} ${LIBM} -D${CRYPTED_PASS} -D${USE_SHA} -o ${PROGNAME} ${SOURCES}
+	${CC} ${FLAGS} -D${CRYPTED_PASS} -D${USE_SHA} -o ${PROGNAME} ${SOURCES} ${LIBS} ${LIBM}
 
 apgd:
-	${CC} ${FLAGS} ${CS_LIBS} ${LIBM} -DCLISERV -D${USE_SHA} -o ${CS_PROGNAME} ${SOURCES}
+	${CC} ${FLAGS} -DCLISERV -D${USE_SHA} -o ${CS_PROGNAME} ${SOURCES} ${CS_LIBS} ${LIBM}
 
 apgbfm:
-	${CC} ${FLAGS} ${LIBM} -o ${BFM_PROGNAME} ${BFM_SOURCES}
+	${CC} ${FLAGS} -DAPGBFM -o ${BFM_PROGNAME} ${BFM_SOURCES} ${LIBM}
 
 strip:
 	strip ${PROGNAME}
@@ -136,4 +144,4 @@
 fi
 
 clean:
-	rm -f ${CS_PROGNAME} ${PROGNAME} ${BFM_PROGNAME} ${OBJECTS} core*
+	rm -f ${CS_PROGNAME} ${PROGNAME} ${BFM_PROGNAME} ${OBJECTS} *core*

=== debian/changelog ===
apg (2.2.3.dfsg.1-7) unstable; urgency=medium

  * fix wrong clamp-mtime expression in debian/rules.
    Thanks to Chris Lamb (Closes: #1079041)
  * apply more man page pages regarding security warnings.
    Thanks to Christoph Anton Mitterer (Closes: #987952)

 -- Marc Haber <mh+debian-packages@zugschlus.de>  Sun, 25 Aug 2024 09:34:03 +0200

apg (2.2.3.dfsg.1-6) unstable; urgency=medium

  * fix wrong buildflags in Makefile patch.
    Thanks to Emanuele Rocca (Closes: #1070651)
  * migrate to salsa
    * change URIs
    * enable salsa-CI
    * set maintainer to package tracker
  * remove H)omepage field, upstream is gone
  * Standards-Version: 4.7.0
    * make build more verbose (policy)
    * add Rules-Requires-Root
  * lintian:
    * use https in debian/copyright
    * add dfsg explanation to debian/copyright
    * add comment to debian/control as reminder to fix version number
    * get rid of tabs in debian/copyright
    * fix version number in debian watch file
    * add some lintian overrides
    * add DEB_BUILD_MAINT_OPTIONS
    * fix spelling errors in manual page and sources
    * fix spelling error in package description
    * debhelper compat level 13

 -- Marc Haber <mh+debian-packages@zugschlus.de>  Fri, 10 May 2024 13:36:58 +0200

apg (2.2.3.dfsg.1-5) unstable; urgency=low

  * add warning to package description about FIPS 181 deprecation.
    Thanks to kwadronaut (Closes: #849109)
  * patch debian/rules to help with reproducibility.
    Thanks to Jathan and Vadgrant Cascadian (Closes: #870890)
  * Standards-Version: 4.1.0 (no changes necessary)

 -- Marc Haber <mh+debian-packages@zugschlus.de>  Sun, 01 Oct 2017 22:19:40 +0000

apg (2.2.3.dfsg.1-4) unstable; urgency=low

  * add patch from Steve Langasek to use correct compiler (Closes: #734870)
  * add patch from Daniel Shahaf to help reproducible builds (Closes: #833141)
  * fix watch file, add dversionmangle
  * Standards-Version: 3.9.8 (no changes needed)

 -- Marc Haber <mh+debian-packages@zugschlus.de>  Fri, 05 Aug 2016 12:04:46 +0200

apg (2.2.3.dfsg.1-3) unstable; urgency=low

  * Source-format: 3.0 (quilt): add debian/source/{format,local-options}
    (Closes: #664375)
  * move from cdbs to debhelper 9
  * move dpatch patches to quilt, add DEP-3 headers
  * use gzip --no-name to be reproducible.
    Thanks to Chris Lamb (Closes: #778215)
  * fix crash on dictionary starting with whitespace.
    Thanks to Jonathan Vollebregt (Closes: #759477)
  * Use getent passwd root instead of grepping /etc/passwd.
    Thanks to Edmund Grimley Evans (Closes: #783695)
  * Fix typo in apg.1 man page.
    Thanks to Jens Kubieziel (Closes: #488034)
  * fix wrong mode letters in man page.
    Thanks to Xavier Hienne (Closes: #609837)
  * multiple improvements to man page.
    Thanks to Christoph Anton Mitterer (Closes: #764411)
  * improve apg.conf.
    Thanks to Christoph Anton Mitterer (Closes: #541631)
  * apg-wrapper is now a /bin/sh script.
    Thanks to Troy Benjegerdes (Closes: #763202)
  * add Homepage field
  * add Vcs-Git and Vcs-Browser to debian/control
  * debian/watch comment that upstream web page was unreachable
  * debian/control remove upstream url from description
  * debian/control add reference to Ganesan / Davis and upstream abandonment
  * machine-readable debian/copyright
  * standards-version 3.9.7 (no other changes necessary)
  * Makefile: add dpkg-buildflags for hardening
  * move package to collab-maint

 -- Marc Haber <mh+debian-packages@zugschlus.de>  Fri, 11 Mar 2016 22:04:02 +0100

apg (2.2.3.dfsg.1-2) unstable; urgency=low

  * apply patch from Kaare Hviid to improve password quality on
    64bit arches. This should address #412618, but upsteam has not yet
    commented. Thanks to Sami Liedes for spotting this.

 -- Marc Haber <mh+debian-packages@zugschlus.de>  Wed, 20 Jun 2007 17:07:47 +0200

apg (2.2.3.dfsg.1-1) unstable; urgency=low

  * re-pack original sources, removing two RFC files. Closes: #393356
  * apply patch from Paul Martin. Closes: #337116
  * Standards-Version: 3.7.2.2 (no changes necessary)

 -- Marc Haber <mh+debian-packages@zugschlus.de>  Tue, 17 Oct 2006 10:12:49 +0000

apg (2.2.3-4) unstable; urgency=low

  * add APG_TIPS file to package
  * remove apgd from SEE ALSO in man pages, we don't ship apgd. Thanks
    to Dr. Markus Waldeck. Closes: #319592.
  * disable DEB_AUTO_UPDATE_DEBIAN_CONTROL
  * Apply patch to read only as much from /dev/random as actually
    needed. Thanks to Johannes Berg. Closes: #320307
  * Standards-Version: 3.6.2 (no changes needed).

 -- Marc Haber <mh+debian-packages@zugschlus.de>  Sun,  2 Oct 2005 12:45:12 +0000

apg (2.2.3-3) unstable; urgency=low

  * use alternative watchfile syntax to make debian/watch work
  * rebuild to fix build dependencies. Closes: #297118.
  * convert repository to svn and debian-only layout.
  * pull directly patched Makefile to debian/patches/02_Makefile
  * remove dpatch from build-depends, cdbs now determines that by itself.

 -- Marc Haber <mh+debian-packages@zugschlus.de>  Sun, 27 Feb 2005 11:37:14 +0000

apg (2.2.3-2) unstable; urgency=low

  * Add upstream URL to description. Closes: #247981.
  * Add debian/watch which unfortunately had to stay disabled since
    the upstream web site doesn't allow directory listings.
  * drop wrong potato backporting comment from debian/rules.
  * Convert package to cdbs.
  * Make package use dpatch.
  * Fix executeable path in index.php. Closes: #273438.

 -- Marc Haber <mh+debian-packages@zugschlus.de>  Mon, 20 Dec 2004 12:25:13 +0000

apg (2.2.3-1) unstable; urgency=low

  * new upstream version
  * set -t both in wrapper and default apg.conf

 -- Marc Haber <mh+debian-packages@zugschlus.de>  Mon, 22 Sep 2003 12:43:10 +0000

apg (2.2.2-1) unstable; urgency=low

  * new upstream version, this time using pristine sources again

 -- Marc Haber <mh+debian-packages@zugschlus.de>  Mon,  1 Sep 2003 14:41:05 +0000

apg (2.2.0-1) unstable; urgency=low

  * new upstream version


=== debian/control ===
Source: apg
Section: admin
Priority: optional
Maintainer: Marc Haber <apg@packages.debian.org>
Uploaders: Marc Haber <mh+debian-packages@zugschlus.de>
Build-Depends: debhelper-compat (= 13)
Standards-Version: 4.7.0
Rules-Requires-Root: binary-targets
Vcs-Git: https://salsa.debian.org/debian/apg.git
Vcs-Browser: https://salsa.debian.org/debian/apg
# apg source: dot-before-repack-count 2.2.3.dfsg.1-6~0 - reminder to change
# to +dfsg1- for next upstream release

Package: apg
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Automated Password Generator - Standalone version
 APG (Automated Password Generator) is the tool set for random
 password generation. It generates some random words of required type
 and prints them to standard output. This binary package contains only
 the standalone version of apg.
 Advantages:
  * Built-in ANSI X9.17 RNG (Random Number Generator)(CAST/SHA1)
  * Built-in password quality checking system (now it has support for Bloom
    filter for faster access)
  * Two Password Generation Algorithms:
     1. Pronounceable Password Generation Algorithm (according to NIST
        FIPS 181)
     2. Random Character Password Generation Algorithm with 35
        configurable modes of operation
  * Configurable password length parameters
  * Configurable amount of generated passwords
  * Ability to initialize RNG with user string
  * Support for /dev/random
  * Ability to crypt() generated passwords and print them as additional output.
  * Special parameters to use APG in script
  * Ability to log password generation requests for network version
  * Ability to control APG service access using tcpd
  * Ability to use password generation service from any type of box (Mac,
    WinXX, etc.) that connected to network
  * Ability to enforce remote users to use only allowed type of password
    generation
 The client/server version of apg has been deliberately omitted.
 .
 Please note that there are security flaws in pronounceable
 password generation schemes (see Ganesan / Davis "A New Attack on
 Random Pronounceable Password Generators", in "Proceedings of the 17th
 National Computer Security Conference (NCSC), Oct. 11-14, 1994
 (Volume 1)", http://csrc.nist.gov/publications/history/nissc/
 1994-17th-NCSC-proceedings-vol-1.pdf, pages 203-216)
 .
 Also note that the FIPS 181 standard from 1993 has been withdrawn by NIST in
 2015 with no superseding publication. This means that the document is
 considered by its publicher as obsolete and not been updated to reference
 current or revised voluntary industry standards, federal specifications, or
 federal data standards.
 .
 apg has not seen upstream attention since 2003, upstream is not answering
 e-mail, and the upstream web page (http://www.adel.nursat.kz/apg/) has been
 gone for years.  The Debian maintainer plans to discontinue apg maintenance as
 soon as an actually maintained software with a comparable feature set becomes
 available.

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_GNU_TYPE	?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE	?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
CC="$(DEB_HOST_GNU_TYPE)-gcc"
else
CC=gcc
endif

%:
	dh $@

override_dh_auto_build:
	make standalone CC=$(CC)

override_dh_auto_install:
	make install INSTALL_PREFIX=$(CURDIR)/debian/apg/usr
	mv $(CURDIR)/debian/apg/usr/bin/apg $(CURDIR)/debian/apg/usr/lib/apg/apg
	tar --create --verbose --file - --directory $(CURDIR)/php/apgonline/ \
	  --clamp-mtime --mtime="@$(SOURCE_DATE_EPOCH)" \
	  --mode=u=rwX,go=rX --sort=name . | gzip --no-name > php.tar.gz
	install -D --mode=0644 php.tar.gz $(CURDIR)/debian/apg/usr/share/doc/apg/php.tar.gz
	rm php.tar.gz
	install -D --mode=0755 $(CURDIR)/debian/apg.wrapper $(CURDIR)/debian/apg/usr/bin/apg
	install -D --mode=0644 $(CURDIR)/debian/apg.conf $(CURDIR)/debian/apg/etc/apg.conf

=== debian/watch ===
version=4
opts=dversionmangle=s/\.dfsg.[0-9]*// \
http://www.adel.nursat.kz/apg/download.shtml download/apg-([^b]+)\.tar\.gz debian
